// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice


//#define ETH_DEBUG

#include "cor_ethernet.h"


//ethernet RX and TX buffers
unsigned char g_RecvBuf[MAXRXFRAMEC];
unsigned char g_SendBuf[MAXTXFRAMEC];

int GetRxBuffer(void){return (int)g_RecvBuf;}
int GetTxBuffer(void){return (int)g_SendBuf;}

void Init_Ethernet(void)
{
	g_srcport = 0x0400;
	g_srcport |= LPC_TIM0->TC & 0x03FF;//randomize using microsecond counter

	if(Found_Ethernet())
	{
		printf("Ethernet connected\r\n\r\n"); 
		printf("MyIP %d.%d.%d.%d\r\n",MyIP[0],MyIP[1],MyIP[2],MyIP[3]);
		printf("MyMAC %02X %02X %02X %02X %02X %02X\r\n",MyMAC[0],MyMAC[1],MyMAC[2],MyMAC[3],MyMAC[4],MyMAC[5]);
	}
	
}

void ProcessTCPFrame(void)
{
	eth_ip_tcp* rx_tcp = (eth_ip_tcp*)GetRxBuffer();

	if (MEMCMP((char*)MyIP, (char*)rx_tcp->dstipaddr, 4)) return; // its not for me
	
	unsigned short dstport = swapw(rx_tcp->dstport);

	if(dstport == TCP_PORT_HTTP ){
		//printf(" HTTP\r\n");
		Handle_HTTP();
	}
}


// must be called from user program periodically (the more often the better)
// handles network, TCP/IP-stack and user events
int Poll_Ethernet(void)
{
	eth_ip_tcp* frame;

	if (CheckFrameReceived(GetRxBuffer()))	// Packet received, Feeds the WatchDog
	{
		frame = (eth_ip_tcp*)GetRxBuffer();
		if(frame->eth_type == FRAME_ARP)
				Handle_ARP();
		else if(frame->eth_type == FRAME_IP)
		{
			if ( (frame->vhl != IPV4) )
			{
				printf("IP Only accepts IPv4 with IHL=5 (20 Bytes Header)\r\n");
				printf("vhl %X tos %X\r\n",frame->vhl,frame->tos);
				return 0; // BAIL
			}
			
   			if ( swapw(frame->ipoffset) & (IP_FLAG_MOREFRAG | IP_FRAGOFS_MASK))	
			{
				printf("IP Only accepts unfragmented frames\r\n");
				return 0; // BAIL
			}
			
			if(frame->proto == PROT_ICMP)
				Handle_ICMP();
			else if(frame->proto == PROT_TCP)
				ProcessTCPFrame();
			//else printf("Unknown Protocol 0x%02X (%d d)\r\n",frame->proto,frame->proto);
		}
		
		//else printf("Unknown Frame Type 0x%04X\r\n",swapw(frame->eth_type));
	
		return 1;
	}
	else
		return 0;
}


// !! NOTE !! null terminate chksum data if length could be odd
// !! NEW NOTE !! MAKE SURE LENGTH IS NOT ODD
unsigned short UIP_ChkSum(unsigned char *sdata, unsigned short len)
{
    unsigned char lbMSB;
    unsigned char v[2];//WORD_VAL checkSum;
    unsigned char Checkbyte;
	unsigned short i;

    lbMSB = 1;
    v[0]=0;//checkSum.Val = 0;
	v[1]=0;
	i=0;
    
	while( len-- )
    {
        Checkbyte = sdata[i++];
        if ( !lbMSB ){
            if ( (v[0] = Checkbyte+v[0]) < Checkbyte){
                if ( ++v[1] == 0 ) v[0]++;
            }
        }else{
            if ( (v[1] = Checkbyte+v[1]) < Checkbyte){
                if ( ++v[0] == 0 ) v[1]++;
            }
        }
        lbMSB = !lbMSB;
    }
    v[1] = ~v[1];
    v[0] = ~v[0];
    return (v[1]<<8)+v[0];//checkSum.Val;
}


void IntToChar4(char* ipchar, int ipint)
{
	ipchar[0] = (ipint>>24) & 0xFF;//0;
	ipchar[1] = (ipint>>16) & 0xFF;//1;
	ipchar[2] = (ipint>>8 ) & 0xFF;//2;
	ipchar[3] = ipint       & 0xFF;//3;
}

