// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice


#ifndef COR_ETHERNET_H
#define COR_ETHERNET_H

#include "pcb.h"

#define MAXRXFRAMEC	(1518)
#define MAXTXFRAMEC	(1514) //4 less than recv

#define MAX_TCPSIZE 	1460  //1500 - 40, NOTE make sure this is an even number for checksum

#define IP_FLAG_MOREFRAG	0x2000	// more fragments available
#define IP_FRAGOFS_MASK		0x1FFF	// indicates where this fragment belongs

// frame types (stored in Type/Length field)
#define FRAME_ARP       0x0608	//byte swapped 0x0806
#define FRAME_IP        0x0008	//byte swapped 0x0800

#define IPV4			0x45	//IPv4 with IHL=5 (20 Bytes Header) TOS=0

#define PROT_ICMP		1		//Internet Control Message Protocol
#define PROT_TCP		6		//Transmission Control Protocol
#define PROT_UDP		17		//User Datagram Protocol

#define TCP_PORT_HTTP   0x0050	//Port 80 HTTP
#define TCP_PORT_FTPC   0x0015	//Port 21 FTP Control
#define TCP_PORT_FTPD   0x0014	//Port 20 FTP Data
#define TCP_PORT_SMTP   0x0019	//Port 25 SMTP (email)


extern unsigned char MyMAC[];
extern unsigned char MyIP[];



char g_searchName[16];//15 plus null
unsigned char g_searchMAC[6];
unsigned char g_searchIP[4];

unsigned char DHCP_MAC[6];
unsigned char DHCP_IP[4];
unsigned char DNS_IP[4];

//handy defines for easier reading
#define DHCPMacIsNotNull (DHCP_MAC[0] || DHCP_MAC[1] || DHCP_MAC[2] || DHCP_MAC[3] || DHCP_MAC[4] || DHCP_MAC[5])
#define DHCPMacIsNull (!DHCPMacIsNotNull)
#define SearchMacIsNotNull (g_searchMAC[0] || g_searchMAC[1] || g_searchMAC[2] || g_searchMAC[3] || g_searchMAC[4] || g_searchMAC[5])
#define SearchIPIsNotNull (g_searchIP[0] || g_searchIP[1] || g_searchIP[2] || g_searchIP[3] )

#define swapw(x) ( (x<<8) + (x>>8) )


unsigned short g_ipid;
unsigned short g_srcport;

#define Char4ToInt(ipchar) ((ipchar[0] << 24) | (ipchar[1] << 16) | (ipchar[2] << 8) | ipchar[3])
void IntToChar4(char* ipchar, int ipint);


int GetTxBuffer(void);
int GetRxBuffer(void);

void Init_Ethernet(void);
unsigned short UIP_ChkSum(unsigned char *sdata, unsigned short len);

int Poll_Ethernet(void);
extern void Check_TCP_Tx(void);


#endif
