// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice


#include "cor_ethernet.h"

//respond to ARP queries or fill in g_searchMAC based on ARP answer received
void Handle_ARP(void)
{
	eth_arp* rx_arp;
	eth_arp* tx_arp;

	rx_arp = (eth_arp*)GetRxBuffer();
	
	//printf(" ARP ");

	if(MEMCMP( (char*)MyIP, (char*)rx_arp->dipaddr,4) ) 
	{
		//printf(" ARP not for me %d.%d.%d.%d\r\n",rx_arp->dipaddr[0],rx_arp->dipaddr[1],rx_arp->dipaddr[2],rx_arp->dipaddr[3]);
		return;//its not for me
	}

	if(rx_arp->opcode == sOP_ARP_ANSWER){
		//printf("OP_ARP_ANSWER\r\n");
		//I have previously sent an ARP request for g_searchIP and have received a reply
		//fill in g_searchMAC and return
		if(!MEMCMP( (char*)g_searchIP, (char*)rx_arp->sipaddr,4))
			MEMCPY(g_searchMAC,rx_arp->shwaddr,6);
		//else printf("not what I was looking for\r\n");
	}
	else if(rx_arp->opcode == sOP_ARP_REQUEST){
		//printf("OP_ARP_REQUEST\r\n");
		//I have received an ARP request for g_MyIP
		//fill in g_MyMAC and send it
		tx_arp = (eth_arp*)GetTxBuffer();

		//setup 14 bytes ETHERNET header
		MEMCPY(tx_arp->dst,rx_arp->src,6);	//dst = src
		MEMCPY(tx_arp->src,(unsigned char*)MyMAC,6);		//src = me
		tx_arp->eth_type = 0x0608;//0806 ARP

		MEMCPY((unsigned char *)(&tx_arp->hwtype),(unsigned char *)(&rx_arp->hwtype),6);//copy hwtype to protolen
		tx_arp->opcode = sOP_ARP_ANSWER;
		MEMCPY(tx_arp->shwaddr,(unsigned char*)MyMAC,6);//copy g_MyMAC
		MEMCPY(tx_arp->sipaddr,(unsigned char*)MyIP,4);//copy g_MyIP, could just swap from rx since I know its me

		MEMCPY(tx_arp->dhwaddr,rx_arp->shwaddr,10);//copy rx MAC and IP
		//Send the frame
		CopyToFrame_EMAC((unsigned char*)tx_arp, 42);
	}
}

