// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice


#include "cor_ethernet.h"

//ICMP (protocol 1) aka ping, accept reply or respond to request
void Handle_ICMP(void)
{
	unsigned short tmp;
	eth_ip_icmp* rx_icmp;
	eth_ip_icmp* tx_icmp;

	unsigned short icmp_length;

	rx_icmp = (eth_ip_icmp*)GetRxBuffer();

	if (MEMCMP((char*)MyIP, (char*)rx_icmp->dstipaddr, 4)) return; // its not for me

	if(rx_icmp->icmp_type == ICMP_ECHO_REQUEST){
		//I have received an ICMP echo request
		tx_icmp = (eth_ip_icmp*)GetTxBuffer();

		//setup 14 bytes ETHERNET header
		MEMCPY(tx_icmp->dst,rx_icmp->src,6);
		MEMCPY(tx_icmp->src,(unsigned char*)MyMAC,6);
		tx_icmp->eth_type = 0x0008;//swapped 0800 IP

		//setup tx_ip header
		MEMCPY((unsigned char *)(&tx_icmp->vhl),(unsigned char *)(&rx_icmp->vhl),10);//copy vhl thru proto

		MEMCPY(tx_icmp->dstipaddr,rx_icmp->srcipaddr,4);//swap or get IPs
		MEMCPY(tx_icmp->srcipaddr,(unsigned char*)MyIP,4);//it was broadcast

		tx_icmp->ipchksum = 0;//clear checksum
		tmp = UIP_ChkSum((unsigned char *)&tx_icmp->vhl,20);//get ip checksum
		tx_icmp->ipchksum = swapw (tmp);

		icmp_length = swapw(rx_icmp->len);
		icmp_length -= 20;//IP header is always 20 bytes for icmp

		MEMCPY((unsigned char*)&tx_icmp->icmp_type,(unsigned char*)&rx_icmp->icmp_type,icmp_length);//copy header and data to include code, id and seqno
		tx_icmp->icmp_type = ICMP_ECHO_REPLY;
		tx_icmp->icmpchksum = 0;
		//for REPLY first 4 bytes are 0 so we could skip them in chksum
		tmp = UIP_ChkSum((unsigned char *)&tx_icmp->icmp_type,40);
		tx_icmp->icmpchksum = swapw(tmp);

		CopyToFrame_EMAC((unsigned char*)tx_icmp, icmp_length + 34);
	}
}


