// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice


#ifndef COR_ETH_IP_ICMP_H
#define COR_ETH_IP_ICMP_H

typedef struct __attribute__((__packed__)){
  unsigned char  dst[6];
  unsigned char  src[6];
  unsigned short eth_type;//0800 IP

  unsigned char  vhl;
  unsigned char  tos;    
  unsigned short len; 
  unsigned short ipid;
  unsigned short ipoffset;
  unsigned char  ttl;
  unsigned char  proto;//1 ICMP
  unsigned short ipchksum;
  unsigned char  srcipaddr[4];
  unsigned char  dstipaddr[4];

  unsigned char  icmp_type;
  unsigned char  icode;
  unsigned short icmpchksum;
  unsigned short id;
  unsigned short seqno;
  unsigned char* data;
} eth_ip_icmp;

#define ICMP_ECHO_REQUEST	8				//message is an echo request
#define ICMP_ECHO_REPLY		0				//message is an echo reply


void Handle_ICMP(void);//ICMP (protocol 1) aka ping, accept reply or respond to request

#endif