// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice


#include "cor_ethernet.h"

void send_tcp(unsigned char cur_sock, unsigned short tcp_data_len, unsigned char flags);//the main function to transmit ethernet data
//void send_page(unsigned char cur_sock);
void close_sock(unsigned char sock_num);
extern void SendPage(unsigned char cur_sock);

const unsigned char HTTP_StandardReply[] = {
0x08,0x00,//eth_type IP
0x45,0x00,//vhl,tos
0x00,0x28,//len set up for ACK
0xDC,0xDC,//msg_id may not matter
0x40,0x00,//flags(no frag) / ipoffset
0x80,0x06,//ttl 128, proto 6 TCP
0x00,0x00,//ipchksum init 0
0xDC,0xDC,0xDC,0xDC,//srcipaddr
0xDC,0xDC,0xDC,0xDC,//dstipaddr
0x00,0x50,//srcport HTTP
0xDC,0xDC,//dstport
0xDC,0xDC,0xDC,0xDC,//seqno
0xDC,0xDC,0xDC,0xDC,//ackno
0x50,//tcpoffset set up for ACK
0x10,//flags set up for ACK
//0x08,0x00,//wnd 2048
0x20,0x00,//wnd 8192
0x00,0x1A,//unsigned short tcpchksum pseudo set up for ACK
0x00,0x00 //unsigned char  urgp
};


void send_tcp(unsigned char cur_sock, unsigned short tcp_data_len, unsigned char flags)
{
	unsigned short tmp;
	unsigned short length;
	eth_ip_tcp* tx_tcp;

	tx_tcp = (eth_ip_tcp*)GetTxBuffer();

	if(tcp_data_len < MAX_TCPSIZE)
		*(unsigned char *)(tx_tcp->data + tcp_data_len) = 0;//for checksum if length is odd, assume MAX_TCPSIZE is even

	//setup 14 bytes ETHERNET header
	MEMCPY(tx_tcp->dst,g_sock[cur_sock].dstmac,6);
	MEMCPY(tx_tcp->src,(unsigned char*)MyMAC,6);

	//setup tx_tcp header
	MEMCPY((unsigned char*)&tx_tcp->eth_type,(unsigned char*)&HTTP_StandardReply,42);
	tx_tcp->flags = flags;
	
	g_ipid++;
	tx_tcp->ipid = swapw(g_ipid);
	MEMCPY(tx_tcp->dstipaddr,g_sock[cur_sock].dstip,4);//swap or get IPs
	MEMCPY(tx_tcp->srcipaddr,(unsigned char*)MyIP,4);//incase its broadcast
	tx_tcp->srcport = g_sock[cur_sock].srcport;
	tx_tcp->dstport = g_sock[cur_sock].dstport;
	MEMCPY((unsigned char *)(&tx_tcp->seqno),(unsigned char *)(&g_sock[cur_sock].seqno),4);
	MEMCPY((unsigned char *)(&tx_tcp->ackno),(unsigned char *)(&g_sock[cur_sock].ackno),4);

//	if( (flags & TCP_CODE_SYN) == TCP_CODE_SYN){//sync or acksync
	if( flags & TCP_CODE_SYN ){//sync or acksync
		//send AckSync with option MSS
		tx_tcp->tcpoffset = 0x60;
		tx_tcp->data[0] = 0x02;//MSS = 1460
		tx_tcp->data[1] = 0x04;
		tx_tcp->data[2] = 0x05;
		tx_tcp->data[3] = 0xB4;
	}

	//setup psuedo checksum with length + proto 6 then swapped
	length = tcp_data_len + 26;//20(tcp_head) 6(proto)
	tx_tcp->tcpchksum = swapw(length);//((length & 0xFF) << 8) + ((length >> 8) & 0xFF);// swapw(length) ?

	//psuedo checksum includes ip src and dst ip
	tmp = UIP_ChkSum((unsigned char *)&tx_tcp->srcipaddr,length + 2);//+ 8(src/dst) - 6 proto above
	tx_tcp->tcpchksum = swapw (tmp);

	//reusing variable copy_length
	length += 14;//20(ip) - 6 proto above

	tx_tcp->len = swapw(length);
	tmp = UIP_ChkSum((unsigned char *)&tx_tcp->vhl,20);//get ip checksum
	tx_tcp->ipchksum = swapw (tmp);

	length += 14;

	//send the frame
	CopyToFrame_EMAC((unsigned char*)tx_tcp, length);
}



//send a packet of a static page
//this is not used in this simple example
/*
const unsigned char httpok_htm[19] = "HTTP/1.0 200 OK\r\n\r\n";
void send_page(unsigned char cur_sock)
{
	unsigned short tcp_data_len, copy_length;
	unsigned char flags;
	eth_ip_tcp* tx_tcp;
	tx_tcp = (eth_ip_tcp*)GetTxBuffer();

	tcp_data_len = 0;
	//if(g_sock[cur_sock].htm_page == 0){
	//	//HTTP/1.0 404 Not Found
	//	tcp_data_len = 159;//I know http404_htm is 159
  	//	MEMCPY(tx_tcp->data, (char *)http404_htm, 159);
	//	g_sock[cur_sock].total_to_send = 0;//??
	//}
	//else 
	if(g_sock[cur_sock].htm_state == 0){//first time through
		g_sock[cur_sock].htm_state = 1;
		tcp_data_len = 19;//I know httpok_htm is 19
		MEMCPY(tx_tcp->data, (char *)httpok_htm, 19);
	}

	if((g_sock[cur_sock].total_to_send + tcp_data_len) > MAX_TCPSIZE)
		copy_length = MAX_TCPSIZE - tcp_data_len;
	else
		copy_length = g_sock[cur_sock].total_to_send;

	
	MEMCPY(tx_tcp->data + tcp_data_len,(char *) g_sock[cur_sock].htm_page, copy_length);

	g_sock[cur_sock].htm_page += (long)copy_length;
	g_sock[cur_sock].total_to_send -= copy_length;
	tcp_data_len += copy_length;

	if(g_sock[cur_sock].total_to_send == 0){
		flags = TCP_CODE_ACK | TCP_CODE_FIN;
		g_sock[cur_sock].state = S_TX_SENT_FIN;//sent last packet and waiting for Ack
	}
	else{
		flags = TCP_CODE_ACK | TCP_CODE_PSH;
		g_sock[cur_sock].state = S_TX_SENT_DATA;//sent a packet and waiting for Ack
	}

	send_tcp(cur_sock, tcp_data_len, flags);
}
*/


void close_sock(unsigned char sock_num)
{
	unsigned char i;

	i = sock_num;

	//move all open sockets down
	while( (i < (MAX_SOCK - 1)) && (g_sock[i+1].state != S_IDLE) ){
		MEMCPY((unsigned char*)&g_sock[i], (unsigned char*)&g_sock[i+1], sizeof(SocketType));
		//printf("copy %d to %d\n",i+1, i);
		i++;
	}
	//clear the last socket
    MEMSET((unsigned char*)&g_sock[i],0,sizeof(SocketType));
	//printf("clear %d\n",i);

}


//TCP (protocol 6) with dst port HTTP
void Handle_HTTP(void)
{
	// !! NOTE !! not checking incoming checksums, seq, ack, window, id or anything

	eth_ip_tcp* rx_tcp;
	unsigned char cur_sock;

	char line[MAX_LINE_LENGTH];//page name length ?
	char* dp;
	unsigned short i, tcp_data_len;//could get by with fewer variables but it gets messy
	unsigned short offset;//used to calculate incoming lengths and reused for parsing POST
	unsigned long ack, seq;
	unsigned char new_seq;
	
	rx_tcp = (eth_ip_tcp*)GetRxBuffer();
	cur_sock = 0xFF;//set for failure -1
	i = 0;

	//see if there is a socket open for this port
	while(g_sock[i].state != S_IDLE && i < MAX_SOCK)
	{
		if( g_sock[i].dstport == rx_tcp->srcport && !MEMCMP((char*)g_sock[i].dstip, (char*)rx_tcp->srcipaddr, 4) )
		{
			//printf("found sock %d\r\n",i);
			cur_sock = i;
			break;
		}
		i++;
	}

	//did not find a socket open
	if(cur_sock == 0xFF)
	{
		if(i == MAX_SOCK)
		{
			//printf("Request denied, no sockets available\r\n");
			return;
		}
		
		//Open a socket.
		//Most likely its a Sync request but AckFin can come in on a closed socket.
		//set current sock, save port, ip, and mac
		cur_sock = i;
		//clear the new socket just to be sure
	    MEMSET((unsigned char*)&g_sock[i],0,sizeof(SocketType));
		g_sock[cur_sock].dstport = rx_tcp->srcport;
		g_sock[cur_sock].srcport = rx_tcp->dstport;//could just copy in 80
		MEMCPY(g_sock[cur_sock].dstip, rx_tcp->srcipaddr, 4);
		MEMCPY(g_sock[cur_sock].dstmac, rx_tcp->src, 6);
	}
	//printf("%d %d ",cur_sock, g_sock[cur_sock].state);

	//save ack and seq
	ack = Char4ToInt(rx_tcp->seqno);
	seq = Char4ToInt(g_sock[cur_sock].seqno);

	// check current seq > last seq
	// might remove check for new_seq, duplicate packets never occur
	if(ack > seq)
		new_seq = 1;
	else
		new_seq = 0;//never happens even with 3.5 sec delay

	//ip_head_len always 20
	i = swapw(rx_tcp->len);
	offset = rx_tcp->tcpoffset>>2;//incoming head length
	tcp_data_len = i - offset - 20;

	//set up standard reply
	//tcpoffset essentially tcp header length, 0x50 = 20 no options, 0x60 = 24 4 bytes options
	if( rx_tcp->flags & (TCP_CODE_SYN | TCP_CODE_FIN) )
		ack++;//Sync and Fin are 0 length but need to inc ack
	else
		ack += tcp_data_len;

	IntToChar4((char*)g_sock[cur_sock].ackno, ack);
	MEMCPY(g_sock[cur_sock].seqno, rx_tcp->ackno, 4);//copy rx ack to tx seq

	//Reset, close the socket
	if( rx_tcp->flags & TCP_CODE_RST ){
		//printf("Reset close\r\n");
		close_sock(cur_sock);
		return;
	}
	
	//sent the last packet, received Ack and AckFin, set up to send Ack and close the socket
	// !! NOTE !! not checking state S_WAIT_ACKFIN, if I get a Fin then I'm Fin
	// there will be no retries for this Ack
	if( (rx_tcp->flags & TCP_CODE_ACKFIN) == TCP_CODE_ACKFIN){
		//NOTICE: when I set the time I use | 1 to make sure it can't get 0 even though there is only a 1 in 4 Billion+ chance of that
		// I use time == 0 to indicate there is nothing for Check_TCP_Tx to do for this socket
		g_sock[cur_sock].time = (LPC_TIM0->TC - HTTP_RETRY_DELAY) | 1;//go now
		g_sock[cur_sock].retry_count = 0;
		g_sock[cur_sock].state = S_TX_ACK_FIN;
		return;
	}
	
	//received new Sync request, set up to send AckSync
	if( rx_tcp->flags & TCP_CODE_SYN ){
		g_sock[cur_sock].time = (LPC_TIM0->TC - HTTP_RETRY_DELAY) | 1;//go now
		g_sock[cur_sock].retry_count = 0;
		g_sock[cur_sock].state = S_RX_SYNC_REQ;
		return;
	}
	
	//I at least need to get an Ack flag
	if( !(rx_tcp->flags & TCP_CODE_ACK) ){
		//maybe send RESET ??
		//printf("no Ack\r\n");
		return;
	}
	//Got an Ack flag, I already know it wasn't an AckFin
	
	//sent AckSync and received Ack, set up to wait 10 seconds for a GET or POST request
	if(g_sock[cur_sock].state == S_TX_ASYNC){
		g_sock[cur_sock].time = (LPC_TIM0->TC + (10000000-HTTP_RETRY_DELAY)) | 1;//nothing to do but wait 10 seconds
		g_sock[cur_sock].state = S_RX_ACK_ASYNC;
		return;
	}

	//sent a packet, received an Ack, set up to send more data which will set state to S_TX_SENT_DATA or S_TX_SENT_FIN
	if(g_sock[cur_sock].state == S_TX_SENT_DATA){
		g_sock[cur_sock].time =  (LPC_TIM0->TC - HTTP_RETRY_DELAY) | 1;//go now
		g_sock[cur_sock].retry_count = 0;
		g_sock[cur_sock].state = S_TX_SEND_DATA;
		return;
	}
	
	//sent the last packet, received an Ack, set up to wait for AckFin
	if(g_sock[cur_sock].state == S_TX_SENT_FIN){
		g_sock[cur_sock].time =  (LPC_TIM0->TC + (10000000-HTTP_RETRY_DELAY)) | 1;//nothing to do but wait 10 seconds
		g_sock[cur_sock].state = S_WAIT_ACKFIN;
		return;
	}

	//At this point I assume I'm receiving data, the first or subsequent packets.
	//PSH may or may not be set and can not be relied upon over various browsers.

	offset = 0;
	dp = (char*)rx_tcp->data;
	
	//see if this is the first of a GET or POST request.
	//MUST check every time in case the browser restarts.
	if(	!STRNCMPI(dp,"GET",3) ){
		//printf("get ");
		offset = 4;
		g_sock[cur_sock].time =  (LPC_TIM0->TC - HTTP_RETRY_DELAY) | 1;//go now
		g_sock[cur_sock].retry_count = 0;
		g_sock[cur_sock].state = S_GOT_REQUEST; //set up to send the first packet
		g_sock[cur_sock].htm_state = 0;//just to make sure, or restart
	}
	else if(!STRNCMPI(dp,"POST",4) ){
		// This simple example does not handle POST. For a full example see EasyWebPlus at
		// http://www.coridiumcorp.com/forum/download/file.php?id=61&sid=706ad6bbbd3877a52f3150076a1d33fd
		//printf("post ");
		offset = 5;
		g_sock[cur_sock].time =  (LPC_TIM0->TC - HTTP_RETRY_DELAY) | 1;//go now
		g_sock[cur_sock].retry_count = 0;
		g_sock[cur_sock].state = S_GOT_REQUEST; //set up to send the first packet
		g_sock[cur_sock].htm_state = 0;//just to make sure, or restart
	}

	//if this is the first of a GET get the URL
	if(offset > 0){
		i = 0;
		while(dp[offset] != ' ' && dp[offset] != '?' && i < 25)//PAGE_NAME_LEN : built in page names are max 15, user file names are max 23 !! remember leading / !!
			line[i++] = dp[offset++];

		if(!new_seq)
			printf("Duplicate packet from GET %s\r\n",line);

		if(i > 24) //file name too long ?? do something or just chop it off ??
			i = 24;
		line[i] = '\0';
		
		if(dp[offset] == '?'){
			i = 0;
			while(dp[offset] != ' '){
				if(i < CGI_BUFFER_SIZE)//just dropping oveflow, you may want to do something different
					g_cgibuf[i++] = dp[offset];
				offset++;
			}
			g_cgibuf[i] = '\0';
			//printf("cgi %d %s\r\n",i,g_cgibuf);
		}

		// set the page function, in this simple example there is only one
		g_sock[cur_sock].func = (void*)SendPage;
		g_sock[cur_sock].htm_state = 0;
	}

}

// Check if any sockets have timed out and need to TX
// Just doing one sock operation at a time, even if it did not require Tx.
// This way we can use one g_SendBuff and know that its always free.
// If there is more than one socket that has timed out we'll be right back to get it next time anyway.
void Check_TCP_Tx(void)
{
	unsigned char cur_sock;
	unsigned long t;

	//Now check Sockets	- just doing one sock operation at a time, even if it did not require Tx
	cur_sock=0; //see if there are any sockets that need service
	while(cur_sock < MAX_SOCK){
		t = LPC_TIM0->TC - g_sock[cur_sock].time;// Note: time is unsigned long so I don't have to worry about negative values
		
		//-10,000,000 is 0xFF676980, that's -10 seconds, once I get a sync from a browser I wait up to 10 seconds for the get or post
		if((g_sock[cur_sock].state != S_IDLE) && (t > HTTP_RETRY_DELAY) && (t < (0 - 10000000)) )
			break;
		cur_sock++;
	}
	//if(cur_sock < MAX_SOCK) printf("\r\ndo %d\r\n",cur_sock);
	
	if(cur_sock >= MAX_SOCK)	
		return;//nothing to do
	
	g_sock[cur_sock].retry_count++;

	if(g_sock[cur_sock].retry_count > HTTP_RETRY_MAX){
		//printf("Retry close_sock\r\n");
		close_sock(cur_sock);//maybe send RESET ??
	}
	
	//nothing to do for S_RX_ACK_ASYNC or S_WAIT_ACKFIN	or S_TX_ASYNC
	//if its been open and idle 10 seconds close it
	else if(g_sock[cur_sock].state == S_RX_ACK_ASYNC || 
	   g_sock[cur_sock].state == S_WAIT_ACKFIN ||
	   g_sock[cur_sock].state == S_TX_ASYNC)
	{
		//printf("%d Idle close_sock %X - %X = %X\r\n",cur_sock, LPC_TIM0->TC, g_sock[cur_sock].time,(LPC_TIM0->TC - g_sock[cur_sock].time));
		close_sock(cur_sock);
	}
	
	//send ACK of ACKFIN
	else if(g_sock[cur_sock].state == S_TX_ACK_FIN)
	{
		send_tcp(cur_sock, 0, TCP_CODE_ACK);
		close_sock(cur_sock);
		//printf("Fin close_sock\r\n");
	}
	
	//NOTE: See below 3 instances of "first time wait just 500 ms". 
	//I use this so that the first retry is done very quickly so the page doesn't seem to hang for 3 seconds
	//I was using 50 ms but now I can't get it to fail and retry to see why I switched to 500 ms, maybe 50 ms was TOO fast
	//If you start seeing retry delays in your browser try setting this back to 50 ms or whatever you want and watch with WireShark to see what's happening
	//This whole timing thing is kinda hard to follow, even by me, and I just did it all new a month ago

	//send or resend ACK SYNC
	else if(g_sock[cur_sock].state == S_RX_SYNC_REQ)
	{
		send_tcp(cur_sock, 4, (TCP_CODE_ACK | TCP_CODE_SYN));
		if(g_sock[cur_sock].retry_count == 1)
			g_sock[cur_sock].time = LPC_TIM0->TC - (HTTP_RETRY_DELAY - 500000);//first time wait just 500 ms
		else
			g_sock[cur_sock].time = LPC_TIM0->TC + HTTP_RETRY_DELAY;//effectively wait double HTTP_RETRY_DELAY
		g_sock[cur_sock].state = S_TX_ASYNC;
		//printf("c S_TX_ASYNC\r\n");
	}
	
	//send or resend data
	else if(g_sock[cur_sock].state == S_GOT_REQUEST   || //first packet
	        g_sock[cur_sock].state == S_TX_SEND_DATA ||  //subsequent packets
	        g_sock[cur_sock].state == S_TX_SENT_DATA ||  //for retry of missed packets
			g_sock[cur_sock].state == S_TX_SENT_FIN) {   //for retry of missed packets
		//send ACK before first packet, if they miss my ack before my response it doesn't seem to matter
		if(g_sock[cur_sock].state == S_GOT_REQUEST){
			send_tcp(cur_sock, 0, TCP_CODE_ACK);
		}

		//if its a resend restore saved states
		if(g_sock[cur_sock].state == S_TX_SENT_DATA || 
		   g_sock[cur_sock].state == S_TX_SENT_FIN)
		{
			g_ipid--;//?? resend same id ??
			g_sock[cur_sock].total_to_send = g_sock[cur_sock].save_to_send;
			g_sock[cur_sock].htm_state = g_sock[cur_sock].save_state;
			g_sock[cur_sock].htm_page = g_sock[cur_sock].save_page;
			//printf("resend\r\n");
		}
		
		else{  //else save states
			g_sock[cur_sock].save_to_send = g_sock[cur_sock].total_to_send;
			g_sock[cur_sock].save_state = g_sock[cur_sock].htm_state;
			g_sock[cur_sock].save_page = g_sock[cur_sock].htm_page;
		}

		g_sock[cur_sock].func(cur_sock);//sets state to S_TX_SENT_DATA or S_TX_SENT_FIN
		
		if(g_sock[cur_sock].retry_count == 1)
			g_sock[cur_sock].time = LPC_TIM0->TC - (HTTP_RETRY_DELAY - 500000);//first time wait just 500 ms
		else
			g_sock[cur_sock].time = LPC_TIM0->TC;
	}

}


// Copy g_cgibuf to a user string buffer
void Read_CGI_In(char * cgi_string)
{	
	int i;
	if(	g_cgibuf[0] )
	{
		//printf("Read_CGI_In len %d %s\r\n",strlen(g_cgibuf), g_cgibuf); //its always 1
		i = 0;
		while(g_cgibuf[i] && i < CGI_BUFFER_SIZE)
		{	
			*cgi_string++ = g_cgibuf[i++];
		}
		*cgi_string++ = 0;
		// avoid multiple returns on 1 message
		g_cgibuf[0] = 0;		
	}
}

void tcpPutch(char ch){
	int i;
	char firstLF;
	
	if(g_OutBufPtr >= HTTP_OUTBUFFSIZE){
		i = 0;
		firstLF = 0;
		while( (i < HTTP_OUTBUFFSIZE) && (firstLF != 0x0A) )
			firstLF = g_xOutBuf[i++];

		if(i == HTTP_OUTBUFFSIZE) i = 79;
		g_OutBufPtr -= i;
		MEMCPY(g_xOutBuf, g_xOutBuf+i, g_OutBufPtr);
	}
	g_xOutBuf[g_OutBufPtr++] = ch;
}




