// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice



.section .startup, "ax"

.global	Reset_Handler
.global _startup
.func   _startup

_startup:

# Exception Vectors


#include "startup_cortex.S"


//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	Cortex parts set stack with the initial vector, so nothing special to do here
//
// Reset_Handler:  the include files above will do any required initialization and fall thru to here


				/* copy .data section (Copy from ROM to RAM) */
                ldr     R1, =_etext
                ldr     R2, =_data
                ldr     R3, =_edata
1:        		
                ldr   R0, [R1]
                str   R0, [R2]
                adds	R1,#4
                adds	R2,#4
				cmp     R2, R3
                blo     1b
                

				/* Clear .bss section (Zero init)  */
                movs    R0, #0
                ldr     R1, =_bss_start
                ldr     R2, =_bss_end
                
2:
                str   	R0, [R1]
                adds	R1,	R1, #4
				cmp     R1, R2
                blo     2b
                

				/* Enter the C code  */
				
 #if (__GNUC__ == 4) && (__GNUC_MINOR__ == 6)	//  && (__GNUC_PATCHLEVEL__ == 0)
 				.extern main_embedded
 
                bl      main_embedded	// need to confuse the linker
 #else                
                bl      main
 #endif               
LoopForever:
				b		LoopForever		// if main ever returns sit here and pout                

.endfunc
.end
