// MWeb
// copyright Coridium Corp., 2014, free for any use with this notice



# Exception Vectors

        .thumb
        .syntax unified

		.extern void NmiSR      
		.extern void FaultISR   
		.extern void FaultMPU   
		.extern void FaultBUS   
		.extern void FaultUSE
		.extern void IntDefaultHandler      

		.extern void UART0_IRQHandler
   	#if	(defined LUMINARY)
   		.extern void EthernetIntHandler
   	#endif
_vectors:
        .word     _stack_end                  // 0 : Top of Stack
        .word     Reset_Handler               // 1 : Reset Handler
        .word     NmiSR                       // 2 : NMI Handler
        .word     FaultISR                    // 3 : Hard Fault Handler
        .word     FaultMPU                    // 4 : The MPU fault handler
        .word     FaultBUS                    // 5 : The bus fault handler
        .word     FaultUSE                    // 6 : The usage fault handler
        .word     0                           // 7 : Reserved
        .word     0                           // 8 : Reserved
        .word     0                           // 9 : Reserved
        .word     0                           // 10: Reserved
        .word     IntDefaultHandler           // 11: SVCall handler
        .word     IntDefaultHandler           // 12: Debug monitor handler
        .word     0                           // 13: Reserved
        .word     IntDefaultHandler           // 14: The PendSV handler
        .word     IntDefaultHandler           // 15: The SysTick handler
        .word     WDT_IRQHandler              // 16: Watchdog Timer
        .word     TIMER0_IRQHandler           // 17: Timer0
        .word     TIMER1_IRQHandler           // 18: Timer1
        .word     TIMER2_IRQHandler           // 19: Timer2
        .word     TIMER3_IRQHandler           // 20: Timer3
        .word     UART0_IRQHandler            // 21: UART0
        .word     UART1_IRQHandler            // 22: UART1
        .word     UART2_IRQHandler            // 23: UART2
        .word     UART3_IRQHandler            // 24: UART3
        .word     PWM1_IRQHandler             // 25: PWM1
        .word     I2C0_IRQHandler             // 26: I2C0
        .word     I2C1_IRQHandler             // 27: I2C1
        .word     I2C2_IRQHandler             // 28: I2C2
        .word     SPIFI_IRQHandler            // 29: SPI
        .word     SSP0_IRQHandler             // 30: SSP0
        .word     SSP1_IRQHandler             // 31: SSP1
        .word     PLL0_IRQHandler             // 32: PLL0 Lock (Main PLL)
        .word     RTC_IRQHandler              // 33: Real Time Clock
        .word     EINT0_IRQHandler            // 34: External Interrupt 0
        .word     EINT1_IRQHandler            // 35: External Interrupt 1
        .word     EINT2_IRQHandler            // 36: External Interrupt 2
        .word     EINT3_IRQHandler            // 37: External Interrupt 3
        .word     ADC_IRQHandler              // 38: A/D Converter
        .word     BOD_IRQHandler              // 39: Brown-Out Detect
        .word     USB_IRQHandler              // 40: USB
        .word     CAN_IRQHandler              // 41: CAN
        .word     DMA_IRQHandler              // 42: General Purpose DMA
        .word     I2S_IRQHandler              // 43: I2S
        .word     ENET_IRQHandler             // 44: Ethernet
        .word     IntDefaultHandler           // 45: Repetitive Interrupt Timer
        .word     MCPWM_IRQHandler            // 46: Motor Control PWM
        .word     QEI_IRQHandler              // 47: Quadrature Encoder Interface
        .word     PLL1_IRQHandler             // 48: PLL1 Lock (USB PLL)
.thumb_func


        .weak		NmiSR                       
        .weak       FaultISR                    
        .weak       FaultMPU                    
        .weak       FaultBUS                    
        .weak       FaultUSE                    
        .weak       IntDefaultHandler
        
NmiSR:
FaultISR:                    
FaultMPU:                    
FaultBUS:                    
FaultUSE:                    
IntDefaultHandler:           
		b			.
        
               
        .weak       WDT_IRQHandler             
        .weak       TIMER0_IRQHandler          
        .weak       TIMER1_IRQHandler          
        .weak       TIMER2_IRQHandler          
        .weak       TIMER3_IRQHandler          
        .weak       UART0_IRQHandler           
        .weak       UART1_IRQHandler           
        .weak       UART2_IRQHandler           
        .weak       UART3_IRQHandler           
        .weak       PWM1_IRQHandler            
        .weak       I2C0_IRQHandler            
        .weak       I2C1_IRQHandler            
        .weak       I2C2_IRQHandler            
        .weak       SPIFI_IRQHandler           
        .weak       SSP0_IRQHandler            
        .weak       SSP1_IRQHandler            
        .weak       PLL0_IRQHandler            
        .weak       RTC_IRQHandler             
        .weak       EINT0_IRQHandler           
        .weak       EINT1_IRQHandler           
        .weak       EINT2_IRQHandler           
        .weak       EINT3_IRQHandler           
        .weak       ADC_IRQHandler             
        .weak       BOD_IRQHandler             
        .weak       USB_IRQHandler             
        .weak       CAN_IRQHandler             
        .weak       DMA_IRQHandler             
        .weak       I2S_IRQHandler             
        .weak       ENET_IRQHandler            
        .weak       MCI_IRQHandler             
        .weak       MCPWM_IRQHandler           
        .weak       QEI_IRQHandler             
        .weak       PLL1_IRQHandler            
        .weak       USBActivity_IRQHandler     
        .weak       CANActivity_IRQHandler     
        .weak       UART4_IRQHandler           
        .weak       SSP2_IRQHandler 
        .weak		M0a_IRQHandler

WDT_IRQHandler:          
TIMER0_IRQHandler:        
TIMER1_IRQHandler:        
TIMER2_IRQHandler:        
TIMER3_IRQHandler:        
UART0_IRQHandler:         
UART1_IRQHandler:         
UART2_IRQHandler:         
UART3_IRQHandler:         
PWM1_IRQHandler:          
I2C0_IRQHandler:          
I2C1_IRQHandler:          
I2C2_IRQHandler:          
SPIFI_IRQHandler:           
SSP0_IRQHandler:          
SSP1_IRQHandler:          
PLL0_IRQHandler:          
RTC_IRQHandler:           
EINT0_IRQHandler:         
EINT1_IRQHandler:         
EINT2_IRQHandler:         
EINT3_IRQHandler:         
ADC_IRQHandler:           
BOD_IRQHandler:           
USB_IRQHandler:           
CAN_IRQHandler:           
DMA_IRQHandler:         
I2S_IRQHandler:           
ENET_IRQHandler:      
MCI_IRQHandler:         
MCPWM_IRQHandler:            
QEI_IRQHandler:           
PLL1_IRQHandler:          
USBActivity_IRQHandler:
CANActivity_IRQHandler:
UART4_IRQHandler:
SSP2_IRQHandler:
LCD_IRQHandler:
GPIO_IRQHandler:
PWM0_IRQHandler:
KFLASH_IRQHandler:
M0a_IRQHandler:

#if 0				// catchall for linker looking for OS calls
	.global	_sbrk
	.global	_exit
	.global	_getpid
	.global	_kill
	.global	__exidx_start
	.global	__exidx_end


_sbrk:
_exit:
_getpid:
_kill:
__exidx_start:
__exidx_end:
#endif
                 
        			b		.
        
 
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	Cortex parts set stack with the initial vector, so nothing special to do here
//
              		.align	2
              		.thumb
              		.thumb_func
Reset_Handler:  

////////////////////////////////////////////////////////////////////////////////////////
//
//   fall thru and do variable initialization, then branch to main

